/*
 * Copyright 2006 Google Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.google.gwt.user.client.rpc;

/**
 * Interface for manipulating a string table.
 * @skip
 */
public interface StringTable {
  /**
   * Add a string to this string table.  Returns the index assigned to this
   * string in the table.
   * 
   * @param string
   * @return index of the string in the string table
   */
  int addString(String string);

  /**
   * Get the string that is associated with the requested index.
   * 
   * @param index
   * @return String associated with the requested index
   */
  String getString(int index);
  
  /**
   * Get the number of strings in the table.
   * 
   * @return the number of strings in the string table.
   */
  int getStringCount();
}
